local mod = ...


local totalBurnTime = 50


-- Particle: Fire -------------------------------------------------------------------------------------
mod:registerAssetId("models/textures/Fire.png", "TEXTURE_FIRE_FIRE")

mod:registerAsset({
    DataType = "MATERIAL",
    Id = "MATERIAL_FIRE_FIRE",
    AlbedoTexture = "TEXTURE_FIRE_FIRE",
})

mod:registerAsset({
    DataType = "PARTICLE_SYSTEM",
    Id = "PARTICLE_SYSTEM_FIRE_FIRE",
    Material = "MATERIAL_FIRE_FIRE",
	BillboardBehavior = "FACE_CAMERA",
    MinimumQuality = "LOW",
	Duration = totalBurnTime,
	Looping = false,
	Delay = { 0, 0 },
	LifeTime = 2.0,
	StartSpeed = { 0.3, 0.3 },
	StartSize = { 10.0, 18.0 },
	StartRotation = { -15, 15 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.02,
	RateOverTime = 2.0,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CONE",
		Angle = 0.1,
		Radius = 0.0001,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.2, 0.0, 0.2 },
		ValueB = { -0.2, 1.0, -0.2 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 10 },
			{ T = 0.2, Alpha = 60 },
			{ T = 0.3, Alpha = 70 },
			{ T = 0.4, Alpha = 80 },
			{ T = 0.5, Alpha = 80 },
			{ T = 0.6, Alpha = 80 },
			{ T = 0.7, Alpha = 40 },
			{ T = 0.8, Alpha = 20 },
			{ T = 0.9, Alpha = 10 },
			{ T = 1.0, Alpha = 0 },
		},
	},
	SizeOverLifetime = {
			{ T = 0.0, Value = 0.20 },
			{ T = 0.5, Value = 0.18 },
			{ T = 1.0, Value = 0.15 },
	},
	RotationOverLifetime = { -40, 40 }
})

mod:registerPrefabComponent("PREFAB_FIRE_FIRE", {
    DataType = "COMP_PARTICLE_EMITTER",
    ParticleSystem = "PARTICLE_SYSTEM_FIRE_FIRE",
    IsPlaying = true,
    IsEmitting = true,
})



-- Particle: Smoke -------------------------------------------------------------------------------------
mod:registerAssetId("models/textures/Smoke.png", "TEXTURE_FIRE_SMOKE")

mod:registerAsset({
    DataType = "MATERIAL",
    Id = "MATERIAL_FIRE_SMOKE",
    AlbedoTexture = "TEXTURE_FIRE_SMOKE",
})

mod:registerAsset({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_FIRE_SMOKE",
	Material = "MATERIAL_FIRE_SMOKE",
	BillboardBehavior = "FACE_CAMERA",
    MinimumQuality = "MEDIUM",
	Duration = totalBurnTime,
	LifeTime = 12,
	Looping = false,
	Delay = { 0, 0 },
	StartSpeed = { 0.1, 0.3 },
	StartSize = { 6.0, 10.0 },
	StartRotation = { -25, 25 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.03,
	RateOverTime = 1.0,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CYLINDER",
		Radius = {0.5, 0.5},
        Height = 2,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.2, 0.1, 0.2 },
		ValueB = { -0.2, -0.1, -0.2 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0.0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1.0, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 20 },
			{ T = 0.8, Alpha = 10 },
			{ T = 1.0, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.4 },
			{ T = 1.0, Value = 0.3 }
	},
	RotationOverLifetime = { -25, 25 }
})

mod:registerPrefabComponent("PREFAB_FIRE_SMOKE", {
    DataType = "COMP_PARTICLE_EMITTER",
    ParticleSystem = "PARTICLE_SYSTEM_FIRE_SMOKE",
    IsPlaying = true,
    IsEmitting = true,
})



-- Particle: Sparks -------------------------------------------------------------------------------------
mod:registerAssetId("models/textures/Spark.png", "TEXTURE_FIRE_SPARK")

mod:registerAsset({
    DataType = "MATERIAL",
    Id = "MATERIAL_FIRE_SPARK",
    AlbedoTexture = "TEXTURE_FIRE_SPARK",
})

mod:registerAsset({
	DataType = "PARTICLE_SYSTEM",
	Id = "PARTICLE_SYSTEM_FIRE_SPARK",
	Material = "MATERIAL_FIRE_SPARK",
	BillboardBehavior = "FACE_CAMERA",
    MinimumQuality = "MEDIUM",
	Duration = totalBurnTime,
	LifeTime = 12,
	Looping = false,
	Delay = { 0, 6 },
	StartSpeed = { 0.6, 0.9 },
	StartSize = { 0.5, 0.5 },
	StartRotation = { -25, 25 },
	StartColor = { 1, 1, 1, 1 },
	GravityModifier = -0.03,
	RateOverTime = 0.50,
	Shape = {
		DataType = "PARTICLE_EMITTER_SHAPE_CYLINDER",
		Radius = {0.5, 0.5},
        Height = 1,
	},
	LinearVelocity = {
		DataType = "PARTICLE_FLOAT3_VALUE_CONSTANT_RANDOM",
		ValueA = { 0.1, 0.1, 0.1 },
		ValueB = { -0.1, -0.1, -0.1 }
	},
	ColorOverLifeTime = {
		DataType = "GRADIENT",
		ColorList = {
			{ T = 0.0, Color = { 0.6, 0.6, 0, 1} },
			{ T = 0.1, Color = { 0.4, 0.4, 0, 1} },
			{ T = 0.5, Color = { 0.4, 0.4, 0.4, 1 } },
			{ T = 1.0, Color = { 0.1, 0.1, 0.1, 0.5 } }
		},
		AlphaList = {
			{ T = 0.1, Alpha = 0 },
			{ T = 0.2, Alpha = 20 },
			{ T = 0.4, Alpha = 30 },
			{ T = 0.6, Alpha = 40 },
			{ T = 0.7, Alpha = 20 },
			{ T = 0.8, Alpha = 10 },
			{ T = 1.0, Alpha = 0 }
		},
	},
	SizeOverLifetime = {
			{ T = 0.1, Value = 0.2 },
			{ T = 0.5, Value = 0.4 },
			{ T = 1.0, Value = 0.3 }
	},
	RotationOverLifetime = { -25, 25 }
})

mod:registerPrefabComponent("PREFAB_FIRE_SPARK", {
    DataType = "COMP_PARTICLE_EMITTER",
    ParticleSystem = "PARTICLE_SYSTEM_FIRE_SPARK",
    IsPlaying = true,
    IsEmitting = true,
})

